<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8">
  <base data-ice="baseUrl" href="../../../../">
  <title data-ice="title">src/components/select/Select.unit.js | formiojs</title>
  <link type="text/css" rel="stylesheet" href="css/style.css">
  <link type="text/css" rel="stylesheet" href="css/prettify-tomorrow.css">
  <script src="script/prettify/prettify.js"></script>
  <script src="script/manual.js"></script>
<meta name="description" content="JavaScript powered Forms with JSON Form Builder"><meta property="twitter:card" content="summary"><meta property="twitter:title" content="formiojs"><meta property="twitter:description" content="JavaScript powered Forms with JSON Form Builder"></head>
<body class="layout-container" data-ice="rootContainer">

<header>
  <a href="./">Home</a>
  
  <a href="identifiers.html">Reference</a>
  <a href="source.html">Source</a>
  
  <div class="search-box">
  <span>
    <img src="./image/search.png">
    <span class="search-input-edge"></span><input class="search-input"><span class="search-input-edge"></span>
  </span>
    <ul class="search-result"></ul>
  </div>
<a href="https://gitlab.com/atorico.com/formio/formio.js.git">Repository</a></header>

<nav class="navigation" data-ice="nav"><div>
  <ul>
    
  <li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/EventEmitter.js~EventEmitter.html">EventEmitter</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/Form.js~Form.html">Form</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/FormBuilder.js~FormBuilder.html">FormBuilder</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/PDFBuilder.js~PDFBuilder.html">PDFBuilder</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/WizardBuilder.js~WizardBuilder.html">WizardBuilder</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-embed">embed</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#builders">builders</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/builders/Builders.js~Builders.html">Builders</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components">components</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/Components.js~Components.html">Components</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components--classes-component">components/_classes/component</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Component">Component</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components--classes-component-editform">components/_classes/component/editForm</a><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-EditFormUtils">EditFormUtils</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components--classes-componentmodal">components/_classes/componentModal</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/_classes/componentModal/ComponentModal.js~ComponentModal.html">ComponentModal</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components--classes-field">components/_classes/field</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/_classes/field/Field.js~Field.html">Field</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components--classes-nested">components/_classes/nested</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/_classes/nested/NestedComponent.js~NestedComponent.html">NestedComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-NestedComponent">NestedComponent</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-address">components/address</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Address">Address</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-button">components/button</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Button">Button</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-checkbox">components/checkbox</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/checkbox/Checkbox.js~CheckBoxComponent.html">CheckBoxComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Checkbox">Checkbox</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-columns">components/columns</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/columns/Columns.js~ColumnsComponent.html">ColumnsComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Columns">Columns</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-container">components/container</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/container/Container.js~ContainerComponent.html">ContainerComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Container">Container</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-content">components/content</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/content/Content.js~ContentComponent.html">ContentComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Content">Content</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-currency">components/currency</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/currency/Currency.js~CurrencyComponent.html">CurrencyComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Currency">Currency</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-datagrid">components/datagrid</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-DataGrid">DataGrid</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-datamap">components/datamap</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/datamap/DataMap.js~DataMapComponent.html">DataMapComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-DataMap">DataMap</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-datetime">components/datetime</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/datetime/DateTime.js~DateTimeComponent.html">DateTimeComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-DateTime">DateTime</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-day">components/day</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Day">Day</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-editgrid">components/editgrid</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-EditGrid">EditGrid</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-email">components/email</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/email/Email.js~EmailComponent.html">EmailComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Email">Email</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-fieldset">components/fieldset</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/fieldset/Fieldset.js~FieldsetComponent.html">FieldsetComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Fieldset">Fieldset</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-file">components/file</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-File">File</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-form">components/form</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Form">Form</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-hidden">components/hidden</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/hidden/Hidden.js~HiddenComponent.html">HiddenComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Hidden">Hidden</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-html">components/html</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/html/HTML.js~HTMLComponent.html">HTMLComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-HTML">HTML</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-number">components/number</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/number/Number.js~NumberComponent.html">NumberComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Number">Number</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-panel">components/panel</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Panel">Panel</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-password">components/password</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/password/Password.js~PasswordComponent.html">PasswordComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Password">Password</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-phonenumber">components/phonenumber</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/phonenumber/PhoneNumber.js~PhoneNumberComponent.html">PhoneNumberComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-PhoneNumber">PhoneNumber</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-radio">components/radio</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/radio/Radio.js~RadioComponent.html">RadioComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Radio">Radio</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-recaptcha">components/recaptcha</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/recaptcha/ReCaptcha.js~ReCaptchaComponent.html">ReCaptchaComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-ReCaptcha">ReCaptcha</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-resource">components/resource</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/resource/Resource.js~ResourceComponent.html">ResourceComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Resource">Resource</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-select">components/select</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Select">Select</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-select-fixtures">components/select/fixtures</a><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-multiSelect">multiSelect</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-multiSelectOptions">multiSelectOptions</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-selectboxes">components/selectboxes</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-SelectBoxes">SelectBoxes</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-signature">components/signature</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/signature/Signature.js~SignatureComponent.html">SignatureComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Signature">Signature</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-survey">components/survey</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Survey">Survey</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-table">components/table</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/table/Table.js~TableComponent.html">TableComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Table">Table</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-tabs">components/tabs</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/tabs/Tabs.js~TabsComponent.html">TabsComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Tabs">Tabs</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-tags">components/tags</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/tags/Tags.js~TagsComponent.html">TagsComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Tags">Tags</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-textarea">components/textarea</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-TextArea">TextArea</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-textfield">components/textfield</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-TextField">TextField</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-time">components/time</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/time/Time.js~TimeComponent.html">TimeComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Time">Time</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-tree">components/tree</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/tree/Node.js~Node.html">Node</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Tree">Tree</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-unknown">components/unknown</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/unknown/Unknown.js~UnknownComponent.html">UnknownComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Unknown">Unknown</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-url">components/url</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/url/Url.js~UrlComponent.html">UrlComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Url">Url</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-well">components/well</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/well/Well.js~WellComponent.html">WellComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Well">Well</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#contrib">contrib</a><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-Contrib">Contrib</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#contrib-edittable">contrib/edittable</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/contrib/edittable/EditTable.js~EditTableComponent.html">EditTableComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-EditTable">EditTable</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#contrib-location">contrib/location</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/contrib/location/Location.js~LocationComponent.html">LocationComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Location">Location</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#contrib-modaledit">contrib/modaledit</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/contrib/modaledit/ModalEdit.js~ModalEditComponent.html">ModalEditComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-ModalEdit">ModalEdit</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#contrib-stripe-checkout">contrib/stripe/checkout</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/contrib/stripe/checkout/StripeCheckout.js~StripeCheckoutComponent.html">StripeCheckoutComponent</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#contrib-stripe-stripe">contrib/stripe/stripe</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/contrib/stripe/stripe/Stripe.js~StripeComponent.html">StripeComponent</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#displays">displays</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/displays/Displays.js~Displays.html">Displays</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#providers">providers</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/providers/Providers.js~Providers.html">Providers</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#providers-address">providers/address</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/providers/address/AddressProvider.js~AddressProvider.html">AddressProvider</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/providers/address/AzureAddressProvider.js~AzureAddressProvider.html">AzureAddressProvider</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/providers/address/CustomAddressProvider.js~CustomAddressProvider.html">CustomAddressProvider</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/providers/address/NominatimAddressProvider.js~NominatimAddressProvider.html">NominatimAddressProvider</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#providers-processor">providers/processor</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-fileProcessor">fileProcessor</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#providers-storage">providers/storage</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-azure">azure</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-base64">base64</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-dropbox">dropbox</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-indexeddb">indexeddb</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-s3">s3</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-getFormioUploadAdapterPlugin">getFormioUploadAdapterPlugin</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-url">url</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-setXhrHeaders">setXhrHeaders</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-XHR">XHR</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#templates">templates</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/templates/Templates.js~Templates.html">Templates</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#templates-bootstrap">templates/bootstrap</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-iconClass">iconClass</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#utils">utils</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/utils/ChoicesWrapper.js~ChoicesWrapper.html">ChoicesWrapper</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-checkInvalidDate">checkInvalidDate</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-lessOrGreater">lessOrGreater</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-applyFormChanges">applyFormChanges</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-eachComponent">eachComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-escapeRegExCharacters">escapeRegExCharacters</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-findComponent">findComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-findComponents">findComponents</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-flattenComponents">flattenComponents</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-formatAsCurrency">formatAsCurrency</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-generateFormChange">generateFormChange</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-getComponent">getComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-getStrings">getStrings</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-getValue">getValue</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-hasCondition">hasCondition</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-isLayoutComponent">isLayoutComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-matchComponent">matchComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-parseFloatExt">parseFloatExt</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-removeComponent">removeComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-searchComponents">searchComponents</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-KEY_CODES">KEY_CODES</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-Evaluator">Evaluator</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-CALENDAR_ERROR_MESSAGES">CALENDAR_ERROR_MESSAGES</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#utils-jsonlogic">utils/jsonlogic</a><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-lodashOperators">lodashOperators</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#validator">validator</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/validator/Rules.js~Rules.html">Rules</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/validator/Validator.js~ValidationChecker.html">ValidationChecker</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#widgets">widgets</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/widgets/InputWidget.js~InputWidget.html">InputWidget</a></span></span></li>
</ul>
</div>
</nav>

<div class="content" data-ice="content"><h1 data-ice="title">src/components/select/Select.unit.js</h1>
<pre class="source-code line-number raw-source-code"><code class="prettyprint linenums" data-ice="content">import assert from &apos;power-assert&apos;;
import cloneDeep from &apos;lodash/cloneDeep&apos;;
import Harness from &apos;../../../test/harness&apos;;
import SelectComponent from &apos;./Select&apos;;
import { expect } from &apos;chai&apos;;
import NativePromise from &apos;native-promise-only&apos;;
import Formio from &apos;./../../Formio&apos;;
import _ from &apos;lodash&apos;;

import {
  comp1,
  comp2,
  multiSelect,
  multiSelectOptions,
  comp4,
  comp5,
  comp6,
  comp7,
  comp8,
  comp9,
  comp10,
  comp11,
  comp12
} from &apos;./fixtures&apos;;

describe(&apos;Select Component&apos;, () =&gt; {
  it(&apos;should not stringify select option value&apos;, function(done) {
    Harness.testCreate(SelectComponent, comp6).then((component) =&gt; {
      component.setValue({ value:&apos;a&apos;, label:&apos;A&apos; });
      setTimeout(()=&gt; {
        assert.equal(component.choices._currentState.items[0].value.value, &apos;a&apos;);
        assert.equal(typeof component.choices._currentState.items[0].value , &apos;object&apos;);
        assert.equal(component.dataValue.value, &apos;a&apos;);
        assert.equal(typeof component.dataValue , &apos;object&apos;);
        done();
      }, 100);
    });
  });

  it(&apos;should return string value for different value types&apos;, function(done) {
    Harness.testCreate(SelectComponent, comp4).then((component) =&gt; {
      const stringValue = component.asString(true);
      const stringValue1 = component.asString(11);
      const stringValue2 = component.asString(&apos;test&apos;);
      const stringValue3 = component.asString(12);
      assert.equal(stringValue, &apos;&lt;span&gt;true&lt;/span&gt;&apos;);
      assert.equal(stringValue1, &apos;&lt;span&gt;11&lt;/span&gt;&apos;);
      assert.equal(stringValue2, &apos;&lt;span&gt;test&lt;/span&gt;&apos;);
      assert.equal(stringValue3, &apos;&lt;span&gt;1.2&lt;/span&gt;&apos;);
      done();
    });
  });

  it(&apos;should correctly determine storage type when dataType is auto&apos;, function(done) {
    Harness.testCreate(SelectComponent, comp4).then((component) =&gt; {
      const value = component.normalizeSingleValue(&apos;true&apos;);
      const value1 = component.normalizeSingleValue(&apos;11&apos;);
      const value2 = component.normalizeSingleValue(&apos;test&apos;);
      const value3 = component.normalizeSingleValue(&apos;11test11test&apos;);
      const value4 = component.normalizeSingleValue(&apos;test11&apos;);
      const value5 = component.normalizeSingleValue(&apos;0&apos;);
      const value6 = component.normalizeSingleValue(&apos;&apos;);
      assert.equal(typeof value, &apos;boolean&apos;);
      assert.equal(typeof value1, &apos;number&apos;);
      assert.equal(typeof value2, &apos;string&apos;);
      assert.equal(typeof value3, &apos;string&apos;);
      assert.equal(typeof value4, &apos;string&apos;);
      assert.equal(typeof value5, &apos;number&apos;);
      assert.equal(typeof value6, &apos;string&apos;);
      done();
    });
  });

  it(&apos;should not stringify default empty values&apos;, function(done) {
    Harness.testCreate(SelectComponent, comp4).then((component) =&gt; {
      const value = component.normalizeSingleValue({});
      const value1 = component.normalizeSingleValue([]);
      assert.equal(typeof value, &apos;object&apos;);
      assert.equal(typeof value1, &apos;object&apos;);
      done();
    });
  });

  it(&apos;should not change value letter case&apos;, function(done) {
    Harness.testCreate(SelectComponent, comp4).then((component) =&gt; {
      const value = component.normalizeSingleValue(&apos;data.textArea&apos;);
      const value1 = component.normalizeSingleValue(&apos;ECMAScript&apos;);
      const value2 = component.normalizeSingleValue(&apos;JS&apos;);
      assert.equal(value, &apos;data.textArea&apos;);
      assert.equal(value1, &apos;ECMAScript&apos;);
      assert.equal(value2, &apos;JS&apos;);
      done();
    });
  });

  it(&apos;should define boolean value&apos;, function(done) {
    Harness.testCreate(SelectComponent, comp4).then((component) =&gt; {
      const value = component.normalizeSingleValue(&apos;TRUE&apos;);
      const value1 = component.normalizeSingleValue(&apos;False&apos;);
      const value2 = component.normalizeSingleValue(&apos;true&apos;);
      assert.equal(value, true);
      assert.equal(value1, false);
      assert.equal(value2, true);
      done();
    });
  });

  it(&apos;1/2 should not display empty choice options if property value is not defined&apos;, function(done) {
    Harness.testCreate(SelectComponent, comp5).then((component) =&gt; {
      component.setItems([{
        &apos;label&apos;: &apos;111&apos;,
        &apos;value&apos;: &apos;111&apos;
      }, {
        &apos;label&apos;: &apos;222&apos;,
        &apos;value&apos;: &apos;222&apos;
      }, {
        &apos;label&apos;: &apos;333&apos;,
        &apos;value&apos;: &apos;333&apos;
      }], false);
      assert.equal(component.selectOptions.length, 0);
      done();
    });
  });

  it(&apos;2/2 should display choice option if property value is set&apos;, function(done) {
    comp5.template = &apos;&lt;span&gt;{{ item.label }}&lt;/span&gt;&apos;;
    Harness.testCreate(SelectComponent, comp5).then((component) =&gt; {
      component.setItems([{
        &apos;label&apos;: &apos;111&apos;,
        &apos;value&apos;: &apos;111&apos;
      }, {
        &apos;label&apos;: &apos;222&apos;,
        &apos;value&apos;: &apos;222&apos;
      }, {
        &apos;label&apos;: &apos;333&apos;,
        &apos;value&apos;: &apos;333&apos;
      }], false);
      assert.equal(component.selectOptions.length, 3);
      done();
    });
  });

  it(&apos;should have only unique dropdown options&apos;, function(done) {
    comp5.template = &apos;&lt;span&gt;{{ item.label }}&lt;/span&gt;&apos;;
    comp5.uniqueOptions = true;
    Harness.testCreate(SelectComponent, comp5).then((component) =&gt; {
      component.setItems([{
        &apos;label&apos;: &apos;Label 1&apos;,
        &apos;value&apos;: &apos;value1&apos;
      }, {
        &apos;label&apos;: &apos;Label 2&apos;,
        &apos;value&apos;: &apos;value2&apos;
      }, {
        &apos;label&apos;: &apos;Label 3&apos;,
        &apos;value&apos;: &apos;value3&apos;
      }, {
        &apos;label&apos;: &apos;Label 4&apos;,
        &apos;value&apos;: &apos;value3&apos;
      }], false);

      assert.equal(component.selectOptions.length, 3);
      done();
    });
  });

  it(&apos;should set multiple selected values not repeating them&apos;, function(done) {
    Harness.testCreate(SelectComponent, multiSelect).then((component) =&gt; {
      component.setItems(multiSelectOptions, false);
      component.setChoicesValue([&apos;Cheers&apos;]);
      component.setChoicesValue([&apos;Cheers&apos;, &apos;Cyberdyne Systems&apos;], 1);
      component.setChoicesValue([&apos;Cheers&apos;, &apos;Cyberdyne Systems&apos;, &apos;Massive Dynamic&apos;], 2);
      const choices = component.element.querySelector(&apos;.choices__list--multiple&apos;).children;
      assert.equal(choices.length, 3);
      done();
    });
  });

  it(&apos;should not show selected values in dropdown when searching&apos;, function(done) {
    Harness.testCreate(SelectComponent, multiSelect).then((component) =&gt; {
      component.setItems(multiSelectOptions, false);
      component.setChoicesValue([&apos;Cheers&apos;]);
      component.setChoicesValue([&apos;Cheers&apos;, &apos;Cyberdyne Systems&apos;], 1);
      component.setItems([], true);
      const itemsInDropdown = component.element.querySelectorAll(&apos;.choices__item--choice&apos;);
      const choices = component.element.querySelector(&apos;.choices__list--multiple&apos;).children;
      assert.equal(choices.length, 2);
      assert.equal(itemsInDropdown.length, 1);
      done();
    });
  });

  it(&apos;Should build a Select component&apos;, () =&gt; {
    return Harness.testCreate(SelectComponent, comp1).then((component) =&gt; {
      Harness.testElements(component, &apos;select&apos;, 1);
    });
  });

  it(&apos;Should preserve the tabindex&apos;, () =&gt; {
    return Harness.testCreate(SelectComponent, comp2).then((component) =&gt; {
      const element = component.element.getElementsByClassName(&apos;choices__list choices__list--single&apos;)[0];
      Harness.testElementAttribute(element, &apos;tabindex&apos;, &apos;10&apos;);
    });
  });

  it(&apos;Should default to 0 when tabindex is not specified&apos;, () =&gt; {
    return Harness.testCreate(SelectComponent, comp1).then((component) =&gt; {
      const element = component.element.getElementsByClassName(&apos;choices__list choices__list--single&apos;)[0];
      Harness.testElementAttribute(element, &apos;tabindex&apos;, &apos;0&apos;);
    });
  });

  it(&apos;Should allow to override threshold option of fuzzy search&apos;, () =&gt; {
    try {
      const c1 = Object.assign(cloneDeep(comp1), { searchThreshold: 0.2 });
      const c2 = Object.assign(cloneDeep(comp1), { searchThreshold: 0.4 });
      const c3 = Object.assign(cloneDeep(comp1), { searchThreshold: 0.8 });
      const comps = [
        Harness.testCreate(SelectComponent, c1),
        Harness.testCreate(SelectComponent, c2),
        Harness.testCreate(SelectComponent, c3),
      ];

      return NativePromise
        .all(comps)
        .then(([a, b, c]) =&gt; {
          expect(a.choices.config.fuseOptions.threshold).to.equal(0.2);
          expect(b.choices.config.fuseOptions.threshold).to.equal(0.4);
          expect(c.choices.config.fuseOptions.threshold).to.equal(0.8);
        });
    }
    catch (error) {
      return NativePromise.reject(error);
    }
  });

  it(&apos;should set component value&apos;, () =&gt; {
    return Harness.testCreate(SelectComponent, comp1).then((component) =&gt; {
      assert.deepEqual(component.dataValue, &apos;&apos;);
      component.setValue(&apos;red&apos;);
      assert.equal(component.dataValue, &apos;red&apos;);
    });
  });

  it(&apos;should remove selected item&apos;, () =&gt; {
    return Harness.testCreate(SelectComponent, comp1).then((component) =&gt; {
      assert.deepEqual(component.dataValue, &apos;&apos;);
      component.setValue(&apos;red&apos;);
      assert.equal(component.dataValue, &apos;red&apos;);

      const element = component.element.getElementsByClassName(&apos;choices__button&apos;)[0];
      component.choices._handleButtonAction(component.choices._store.activeItems, element);

      assert.equal(component.dataValue, &apos;&apos;);
    });
  });

  it(&apos;should open dropdown after item has been removed&apos;, () =&gt; {
    global.requestAnimationFrame = cb =&gt; cb();
    window.matchMedia = window.matchMedia || function() {
      return {
        matches : false,
        addListener : function() {},
        removeListener: function() {}
      };
    };

    return Harness.testCreate(SelectComponent, comp1).then((component) =&gt; {
      component.setValue(&apos;red&apos;);

      const element = component.element.getElementsByClassName(&apos;choices__button&apos;)[0];
      component.choices._handleButtonAction(component.choices._store.activeItems, element);

      component.choices.showDropdown(true);

      assert.equal(component.choices.dropdown.isActive, true);
    });
  });

  it(&apos;should keep dropdown closed after item has been removed by keypress&apos;, () =&gt; {
    return Harness.testCreate(SelectComponent, comp1).then((component) =&gt; {
      component.setValue(&apos;red&apos;);

      const element = component.element.querySelector(&apos;.choices__button&apos;);
      const ke = new KeyboardEvent(&apos;keydown&apos;, {
        bubbles: true, cancelable: true, keyCode: 13
      });

      element.dispatchEvent(ke);

      assert.equal(component.dataValue, &apos;&apos;);
      assert.equal(component.choices.dropdown.isActive, false);
    });
  });

  it(&apos;Should render and set values in selects with different widget types&apos;, (done) =&gt; {
    const form = _.cloneDeep(comp7);
    const element = document.createElement(&apos;div&apos;);

    Formio.createForm(element, form).then(form =&gt; {
      const selectHTML = form.getComponent(&apos;selectHtml&apos;);
      const selectChoices = form.getComponent(&apos;selectChoices&apos;);
      assert.equal(!!selectHTML.choices, false);
      assert.equal(!!selectChoices.choices, true);

      setTimeout(() =&gt; {
        assert.equal(selectChoices.element.querySelectorAll(&apos;.choices__item--choice&apos;).length, 3);
        const value = &apos;b&apos;;
        selectHTML.setValue(value);
        selectChoices.setValue(value);

        setTimeout(() =&gt; {
          assert.equal(selectHTML.dataValue, value);
          assert.equal(selectChoices.dataValue, value);
          assert.equal(selectHTML.getValue(), value);
          assert.equal(selectChoices.getValue(), value);

          done();
        }, 200);
      }, 200);
    }).catch(done);
  });

  it(&apos;Should clear select value when &quot;clear value on refresh options&quot; and &quot;refresh options on&quot; is enable and number component is changed   &apos;, (done) =&gt; {
    const form = _.cloneDeep(comp8);
    const element = document.createElement(&apos;div&apos;);

    Formio.createForm(element, form).then(form =&gt; {
      const select = form.getComponent(&apos;select&apos;);
      const numberComp = form.getComponent(&apos;number&apos;);
      const value = &apos;b&apos;;
      select.setValue(value);

      setTimeout(() =&gt; {
        assert.equal(select.dataValue, value);
        assert.equal(select.getValue(), value);
        const numberInput = numberComp.refs.input[0];
        const numberValue = 5;
        const inputEvent = new Event(&apos;input&apos;);
        numberInput.value = numberValue;
        numberInput.dispatchEvent(inputEvent);

        setTimeout(() =&gt; {
          assert.equal(numberComp.dataValue, numberValue);
          assert.equal(numberComp.getValue(), numberValue);
          assert.equal(select.dataValue, &apos;&apos;);
          assert.equal(select.getValue(), &apos;&apos;);

          done();
        }, 400);
      }, 200);
    }).catch(done);
  });

  it(&apos;Should update select items when &quot;refresh options on&quot; is enable and number component is changed&apos;, (done) =&gt; {
    const form = _.cloneDeep(comp9);
    const element = document.createElement(&apos;div&apos;);
    const originalMakeRequest = Formio.makeRequest;
    Formio.makeRequest = function(formio, type, url) {
      return new Promise(resolve =&gt; {
        let values =[{ name: &apos;Ivan&apos; }, { name: &apos;Mike&apos; }];

        if (url.endsWith(&apos;5&apos;)) {
          values = [{ name: &apos;Kate&apos; }, { name: &apos;Ann&apos; }, { name: &apos;Lana&apos; }];
        }
         resolve(values);
      });
    };

    Formio.createForm(element, form).then(form =&gt; {
      const select = form.getComponent(&apos;select&apos;);
      const numberComp = form.getComponent(&apos;number&apos;);
      setTimeout(() =&gt; {
        assert.equal(select.selectOptions.length, 2);
        assert.deepEqual(select.selectOptions[0].value, { name: &apos;Ivan&apos; });

        const numberValue = 5;
        const inputEvent = new Event(&apos;input&apos;);
        const numberInput = numberComp.refs.input[0];

        numberInput.value = numberValue;
        numberInput.dispatchEvent(inputEvent);

        setTimeout(() =&gt; {
          assert.equal(numberComp.dataValue, numberValue);
          assert.equal(numberComp.getValue(), numberValue);
          assert.equal(select.selectOptions.length, 3);
          assert.deepEqual(select.selectOptions[0].value, { name: &apos;Kate&apos; });

          Formio.makeRequest = originalMakeRequest;
          done();
        }, 500);
      }, 200);
    }).catch(done);
  });

  it(&apos;Should update select items when &quot;refresh options on blur&quot; is enable and number component is changed&apos;, (done) =&gt; {
    const form = _.cloneDeep(comp9);
    form.components[1].refreshOn = null;
    form.components[1].refreshOnBlur = &apos;number&apos;;

    const element = document.createElement(&apos;div&apos;);
    const originalMakeRequest = Formio.makeRequest;
    Formio.makeRequest = function(formio, type, url) {
      return new Promise(resolve =&gt; {
        let values =[{ name: &apos;Ivan&apos; }, { name: &apos;Mike&apos; }];

        if (url.endsWith(&apos;5&apos;)) {
          values = [{ name: &apos;Kate&apos; }, { name: &apos;Ann&apos; }, { name: &apos;Lana&apos; }];
        }
         resolve(values);
      });
    };

    Formio.createForm(element, form).then(form =&gt; {
      const select = form.getComponent(&apos;select&apos;);
      const numberComp = form.getComponent(&apos;number&apos;);
      setTimeout(() =&gt; {
        assert.equal(select.selectOptions.length, 2);
        assert.deepEqual(select.selectOptions[0].value, { name: &apos;Ivan&apos; });

        const numberValue = 5;
        const inputEvent = new Event(&apos;input&apos;);
        const focusEvent = new Event(&apos;focus&apos;);
        const blurEvent = new Event(&apos;blur&apos;);
        const numberInput = numberComp.refs.input[0];
        numberInput.dispatchEvent(focusEvent);
        numberInput.value = numberValue;
        numberInput.dispatchEvent(inputEvent);
        numberInput.dispatchEvent(blurEvent);

        setTimeout(() =&gt; {
          assert.equal(numberComp.dataValue, numberValue);
          assert.equal(numberComp.getValue(), numberValue);
          assert.equal(select.selectOptions.length, 3);
          assert.deepEqual(select.selectOptions[0].value, { name: &apos;Kate&apos; });

          Formio.makeRequest = originalMakeRequest;
          done();
        }, 500);
      }, 200);
    }).catch(done);
  });

  it(&apos;Should be able to search if static search is enable&apos;, (done) =&gt; {
    const form = _.cloneDeep(comp10);
    const element = document.createElement(&apos;div&apos;);

    Formio.createForm(element, form).then(form =&gt; {
      const select = form.getComponent(&apos;select&apos;);

      const searchField = select.element.querySelector(&apos;.choices__input.choices__input--cloned&apos;);
      const focusEvent = new Event(&apos;focus&apos;);
      searchField.dispatchEvent(focusEvent);

      setTimeout(() =&gt; {
        assert.equal(select.choices.dropdown.isActive, true);
        const items = select.choices.choiceList.element.children;
        assert.equal(items.length, 5);

        const keyupEvent = new Event(&apos;keyup&apos;);
        const searchField = select.element.querySelector(&apos;.choices__input.choices__input--cloned&apos;);
        searchField.value = &apos;par&apos;;
        searchField.dispatchEvent(keyupEvent);

        setTimeout(() =&gt; {
          const items = select.choices.choiceList.element.children;
          assert.equal(items.length, 1);

          done();
        }, 400);
      }, 200);
    }).catch(done);
  });

  it(&apos;Should not be able to search if static search is disable&apos;, (done) =&gt; {
    const form = _.cloneDeep(comp10);
    form.components[0].searchEnabled = false;
    const element = document.createElement(&apos;div&apos;);

    Formio.createForm(element, form).then(form =&gt; {
      const select = form.getComponent(&apos;select&apos;);
      const searchField = select.element.querySelector(&apos;.choices__input.choices__input--cloned&apos;);
      assert.equal(searchField, null);

      done();
    }).catch(done);
  });

  it(&apos;Should save correct value if value property and item template property are different&apos;, (done) =&gt; {
    const form = _.cloneDeep(comp9);
    form.components[1].refreshOn = null;
    form.components[1].valueProperty = &apos;age&apos;;
    form.components[1].lazyLoad = true;

    const element = document.createElement(&apos;div&apos;);
    const originalMakeRequest = Formio.makeRequest;

    Formio.makeRequest = function() {
      return new Promise(resolve =&gt; {
        const values =[{ name: &apos;Ivan&apos;, age: 35 }, { name: &apos;Mike&apos;, age: 41 }];
        resolve(values);
      });
    };

    Formio.createForm(element, form).then(form =&gt; {
      const select = form.getComponent(&apos;select&apos;);
      assert.equal(select.selectOptions.length, 0);
      select.choices.showDropdown();

      setTimeout(() =&gt; {
        assert.equal(select.selectOptions.length, 2);
        assert.deepEqual(select.selectOptions[0].value, 35);
        assert.deepEqual(select.selectOptions[0].label, &apos;&lt;span&gt;Ivan&lt;/span&gt;&apos;);

        const items = select.choices.choiceList.element.children;
        assert.equal(items.length, 2);
        assert.equal(items[0].textContent.trim(), &apos;Ivan&apos;);

        select.setValue(41);

        setTimeout(() =&gt; {
          assert.equal(select.getValue(), 41);
          assert.equal(select.choices.containerInner.element.children[1].children[0].children[0].textContent, &apos;Mike&apos;);

          Formio.makeRequest = originalMakeRequest;

          done();
        }, 400);
      }, 200);
    }).catch(done);
  });

  it(&apos;Should set custom header when sending request in select url&apos;, (done) =&gt; {
    const form = _.cloneDeep(comp9);
    form.components[1].refreshOn = null;
    form.components[1].lazyLoad = true;
    form.components[1].data.headers = [{ key:&apos;testHeader&apos;, value:&apos;test&apos; }];

    const element = document.createElement(&apos;div&apos;);
    const originalMakeRequest = Formio.makeRequest;

    Formio.makeRequest = function(formio, type, url, method, data, opts) {
      assert.equal(opts.header.get(&apos;testHeader&apos;), &apos;test&apos;);
      return new Promise(resolve =&gt; {
        const values = [{ name: &apos;Ivan&apos;, age: 35 }, { name: &apos;Mike&apos;, age: 41 }];
        resolve(values);
      });
    };

    Formio.createForm(element, form).then(form =&gt; {
      const select = form.getComponent(&apos;select&apos;);
      assert.equal(select.selectOptions.length, 0);
      select.choices.showDropdown();

      setTimeout(() =&gt; {
        Formio.makeRequest = originalMakeRequest;
        done();
      }, 200);
    }).catch(done);
  });

  it(&apos;Should set value in select url with lazy load option&apos;, (done) =&gt; {
    const form = _.cloneDeep(comp9);
    form.components[1].refreshOn = null;
    form.components[1].lazyLoad = true;

    const element = document.createElement(&apos;div&apos;);
    const originalMakeRequest = Formio.makeRequest;

    Formio.makeRequest = function() {
      return new Promise(resolve =&gt; {
        const values = [{ name: &apos;Ivan&apos; }, { name: &apos;Mike&apos; }];
        resolve(values);
      });
    };

    Formio.createForm(element, form).then(form =&gt; {
      const select = form.getComponent(&apos;select&apos;);
      select.setValue({ name: &apos;Ivan&apos; });
      setTimeout(() =&gt; {
        assert.deepEqual(select.getValue(), { name: &apos;Ivan&apos; });
        assert.deepEqual(select.dataValue, { name: &apos;Ivan&apos; });
        assert.equal(select.choices.containerInner.element.children[1].children[0].children[0].textContent, &apos;Ivan&apos;);

        Formio.makeRequest = originalMakeRequest;

        done();
      }, 200);
    }).catch(done);
  });

  it(&apos;Should set value in select url with lazy load option when value property is defined&apos;, (done) =&gt; {
    const form = _.cloneDeep(comp9);
    form.components[1].refreshOn = null;
    form.components[1].lazyLoad = true;
    form.components[1].valueProperty = &apos;name&apos;;
    const element = document.createElement(&apos;div&apos;);
    const originalMakeRequest = Formio.makeRequest;

    Formio.makeRequest = function() {
      return new Promise(resolve =&gt; {
        const values = [{ name: &apos;Ivan&apos; }, { name: &apos;Mike&apos; }];
        resolve(values);
      });
    };

    Formio.createForm(element, form).then(form =&gt; {
      const select = form.getComponent(&apos;select&apos;);
      select.setValue(&apos;Ivan&apos;);
      setTimeout(() =&gt; {
        assert.equal(select.getValue(), &apos;Ivan&apos;);
        assert.equal(select.dataValue, &apos;Ivan&apos;);
        assert.equal(select.choices.containerInner.element.children[1].children[0].children[0].textContent, &apos;Ivan&apos;);

        Formio.makeRequest = originalMakeRequest;

        done();
      }, 200);
    }).catch(done);
  });

  it(&apos;Should be able to search if static search is enable&apos;, (done) =&gt; {
    const form = _.cloneDeep(comp10);
    const element = document.createElement(&apos;div&apos;);

    Formio.createForm(element, form).then(form =&gt; {
      const select = form.getComponent(&apos;select&apos;);

      const searchField = select.element.querySelector(&apos;.choices__input.choices__input--cloned&apos;);
      const focusEvent = new Event(&apos;focus&apos;);
      searchField.dispatchEvent(focusEvent);

      setTimeout(() =&gt; {
        assert.equal(select.choices.dropdown.isActive, true);
        const items = select.choices.choiceList.element.children;
        assert.equal(items.length, 5);

        const keyupEvent = new Event(&apos;keyup&apos;);
        const searchField = select.element.querySelector(&apos;.choices__input.choices__input--cloned&apos;);
        searchField.value = &apos;par&apos;;
        searchField.dispatchEvent(keyupEvent);

        setTimeout(() =&gt; {
          const items = select.choices.choiceList.element.children;
          assert.equal(items.length, 1);

          done();
        }, 400);
      }, 200);
    }).catch(done);
  });

  it(&apos;Should provide &quot;Allow only available values&quot; validation&apos;, (done) =&gt; {
    const form = _.cloneDeep(comp10);
    form.components[0].validate.onlyAvailableItems = true;
    const element = document.createElement(&apos;div&apos;);

    Formio.createForm(element, form).then(form =&gt; {
      const select = form.getComponent(&apos;select&apos;);
      const value = &apos;Dallas&apos;;
      select.setValue(value);

      setTimeout(() =&gt; {
        assert.equal(select.getValue(), value);
        assert.equal(select.dataValue, value);
        const submit = form.getComponent(&apos;submit&apos;);
        const clickEvent = new Event(&apos;click&apos;);
        const submitBtn = submit.refs.button;
        submitBtn.dispatchEvent(clickEvent);

        setTimeout(() =&gt; {
          assert.equal(form.errors.length, 1);
          assert.equal(select.error.message, &apos;Select is an invalid value.&apos;);
          document.innerHTML = &apos;&apos;;
          done();
        }, 400);
      }, 200);
    }).catch(done);
  });

  it(&apos;Should render and set value in select json&apos;, (done) =&gt; {
    const formObj = _.cloneDeep(comp11);
    const element = document.createElement(&apos;div&apos;);

    Formio.createForm(element, formObj).then(form =&gt; {
      const select = form.getComponent(&apos;select&apos;);
      assert.equal(select.choices.containerInner.element.children[1].children[0].dataset.value, formObj.components[0].placeholder);
      select.choices.showDropdown();

      setTimeout(() =&gt; {
        const items = select.choices.choiceList.element.children;
        assert.equal(items.length, 4);

        const value = { value: &apos;a&apos;, label:&apos;A&apos; };
        select.setValue(value);

        setTimeout(() =&gt; {
          assert.deepEqual(select.getValue(), value);
          assert.deepEqual(select.dataValue, value);
          assert.equal(select.choices.containerInner.element.children[1].children[0].children[0].textContent, &apos;A&apos;);

          done();
        }, 400);
      }, 200);
    }).catch(done);
  });

  it(&apos;Should load and set items in select resource and set value&apos;, (done) =&gt; {
    const form = _.cloneDeep(comp12);
    const element = document.createElement(&apos;div&apos;);
    const originalMakeRequest = Formio.makeRequest;

    Formio.makeRequest = function(formio, type, url) {
      return new Promise(resolve =&gt; {
        let values = [{ data: { name: &apos;Ivan&apos; } }, { data: { name: &apos;Mike&apos; } }];

        if (url.endsWith(&apos;Ivan&apos;)) {
          assert.equal(url.endsWith(&apos;/form/60114dd32cab36ad94ac4f94/submission?limit=100&amp;skip=0&amp;data.name__regex=Ivan&apos;), true);
          values = [{ data: { name: &apos;Ivan&apos; } }];
        }
        else {
          assert.equal(url.endsWith(&apos;/form/60114dd32cab36ad94ac4f94/submission?limit=100&amp;skip=0&apos;), true);
        }

        resolve(values);
      });
    };

    Formio.createForm(element, form).then(form =&gt; {
      const select = form.getComponent(&apos;select&apos;);
      const items = select.choices.choiceList.element.children;
      assert.equal(items.length, 1);
      select.setValue(&apos;Ivan&apos;);

      setTimeout(() =&gt; {
        assert.equal(select.getValue(), &apos;Ivan&apos;);
        assert.equal(select.dataValue, &apos;Ivan&apos;);
        assert.equal(select.choices.containerInner.element.children[1].children[0].children[0].textContent, &apos;Ivan&apos;);
        select.choices.showDropdown();

        setTimeout(() =&gt; {
          const items = select.choices.choiceList.element.children;

          assert.equal(items.length, 2);
          assert.equal(items[0].textContent, &apos;Ivan&apos;);

          Formio.makeRequest = originalMakeRequest;
          done();
        }, 400);
      }, 200);
    }).catch(done);
  });
  // it(&apos;should reset input value when called with empty value&apos;, () =&gt; {
  //   const comp = Object.assign({}, comp1);
  //   delete comp.placeholder;
  //
  //   return Harness.testCreate(SelectComponent, comp).then((component) =&gt; {
  //     assert.deepEqual(component.dataValue, &apos;&apos;);
  //     assert.equal(component.refs.input[0].value, &apos;&apos;);
  //     component.setValue(&apos;red&apos;);
  //     assert.equal(component.dataValue, &apos;red&apos;);
  //     assert.equal(component.refs.input[0].value, &apos;red&apos;);
  //     component.setValue(&apos;&apos;);
  //     assert.equal(component.dataValue, &apos;&apos;);
  //     assert.equal(component.refs.input[0].value, &apos;&apos;);
  //   });
  // });
});
</code></pre>

</div>

<footer class="footer">
  Generated by <a href="https://esdoc.org">ESDoc<span data-ice="esdocVersion">(1.1.0)</span><img src="./image/esdoc-logo-mini-black.png"></a>
</footer>

<script src="script/search_index.js"></script>
<script src="script/search.js"></script>
<script src="script/pretty-print.js"></script>
<script src="script/inherited-summary.js"></script>
<script src="script/test-summary.js"></script>
<script src="script/inner-link.js"></script>
<script src="script/patch-for-local.js"></script>
</body>
</html>
